//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Hsrm.Sila2.WebcamService.Contracts;
using System;
using Tecan.Sila2;


namespace Hsrm.Sila2.WebcamService.CameraService
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Take Picture command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TakePictureRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public TakePictureRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public TakePictureRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "de.hsrm/tools/CameraService/v1/Command/TakePicture";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Take Picture command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class TakePictureResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.BinaryDto _returnValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public TakePictureResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="returnValue">A binary with the image</param>
        public TakePictureResponseDto(System.IO.Stream returnValue, Tecan.Sila2.IBinaryStore store)
        {
            ReturnValue = new Tecan.Sila2.BinaryDto(returnValue, store);
        }
        
        /// <summary>
        /// A binary with the image
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.BinaryDto ReturnValue
        {
            get
            {
                return _returnValue;
            }
            set
            {
                _returnValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReturnValue, "returnValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReturnValue, "returnValue"));
        }
    }
}

